import gzip
import os
import orjson
import orjsonl

DATA_PATH = "data/listings/metadata/"

OBJECTS = []
for file in os.listdir(DATA_PATH):
    with gzip.open(DATA_PATH + file, "rt") as gzf:
        print(f"Loading {file}")
        data = [orjson.loads(line) for line in gzf]
        OBJECTS.extend(data)
        print(f"\tFinished loading {file}")
        print(f"\tDataset now contains {len(OBJECTS)} entries")
        del data

orjsonl.save("interim/dataset.jsonl", OBJECTS)
