import polars as pl
DATASET = "interim/dataset.jsonl"

df = pl.read_json(DATASET, json_lines=True)

# remove list
def list_to_string(x):
    tmp = x.apply(lambda y: y["value"])
    if len(tmp) > 1:
        print("PRODUCT HAS MORE THAN ONE TYPE")
    return tmp[0]

def lang_to_text(series):
    # Each series is the list with one or more structs
    result = set()
    for entry in series:
        if entry.get("language_tag")[:2] == "en":
            result.update(entry.get("value").split(" "))
    return " ".join(result).strip()

df2 = df.select([
    pl.col("item_id"),
    pl.col("item_name").apply(lang_to_text),
    pl.col("item_keywords").apply(lang_to_text),
    pl.col("product_type").apply(list_to_string).cast(pl.Categorical)
])

dff = df2.filter(
    pl.col("item_name") != ""
)
dff.to_parquet("interim/eng_dataset.parquet")
dff.to_csv("interim/eng_dataset.csv")

print("SIZE of ALL DATASET", len(df2))
print("SIZE of ALL EN_** LANG DATASET", len(dff))
print("Difference: ", len(df2) - len(dff))