import polars as pl
import numpy as np
import re
from scipy import sparse
from sklearn.feature_extraction.text import TfidfVectorizer

df = pl.read_parquet("interim/eng_dataset.parquet")
remove_numbers = re.compile(r"\d+")
df["item_name"] = df["item_name"].apply(lambda x: remove_numbers.sub(" NUMBER ", x))
df["item_keywords"] = df["item_keywords"].apply(lambda x: remove_numbers.sub(" NUMBER ", x))
df.head(5)

vectorizer = TfidfVectorizer(
    strip_accents='unicode',
    lowercase=True,
    stop_words='english',
    max_features=5000,
)
X = vectorizer.fit_transform(df["item_keywords"].to_list())

sparse.save_npz("interim/tfidf.npz", X)