# %%
import pickle
import sklearn.metrics as m
import numpy as np

# %% [markdown]
# # AP vs LAP

# %%
with open("results/affinty_propagation_20000.pkl", "rb") as f:
    ap = pickle.load(f)
ap

# %%
with open("results/leveraged_affinty_propagation_20000.pkl", "rb") as f:
    lap = pickle.load(f)
lap

# %%
with open("results/leveraged_affinty_propagation_130000.pkl", "rb") as f:
    bg_lap = pickle.load(f)
bg_lap

# %%
print("LAP  20k Netsim", lap.netsim)
print("LAP 130k Netsim", bg_lap.netsim)

# %%
print("AP clusters found",len(np.unique(ap.labels_)))
print("LAP clusters found",len(np.unique(lap.labels_)))
metrics = [
    ("Homogeneity Score", m.homogeneity_score),
    ("Completeness Score", m.completeness_score),
    ("V-measure Score", m.v_measure_score),
    ("Normalized Mutual information Score", m.normalized_mutual_info_score),
    ("Adjusted Mutual information Score", m.adjusted_mutual_info_score),
    ("Rand Index", m.rand_score),
    ("Adjusted Rand Index", m.adjusted_rand_score),
    ("Fowlkes-Mallows", m.fowlkes_mallows_score)
]
for metric in metrics:
    print(metric[0], metric[1](ap.labels_, lap.labels_))

# %%
print("AP clusters found",len(np.unique(ap.labels_)))
print("LAP clusters found",len(np.unique(bg_lap.labels_[:20000])))
metrics = [
    ("Homogeneity Score", m.homogeneity_score),
    ("Completeness Score", m.completeness_score),
    ("V-measure Score", m.v_measure_score),
    ("Normalized Mutual information Score", m.normalized_mutual_info_score),
    ("Adjusted Mutual information Score", m.adjusted_mutual_info_score),
    ("Rand Index", m.rand_score),
    ("Adjusted Rand Index", m.adjusted_rand_score),
    ("Fowlkes-Mallows", m.fowlkes_mallows_score)
]
for metric in metrics:
    print(metric[0], metric[1](ap.labels_, bg_lap.labels_[:20000]), metric[1](bg_lap.labels_[:20000], ap.labels_))

# %%



